"use strict";
const vue = require("vue");
const useAutoRunPlugin = (fetchInstance, { manual, ready = true, refreshDeps = [], refreshDepsAction }) => {
  const hasAutoRun = vue.ref(false);
  vue.watchEffect(() => {
    if (!manual)
      hasAutoRun.value = vue.unref(ready);
  });
  vue.watch(
    [hasAutoRun, ...refreshDeps],
    ([autoRun]) => {
      if (!autoRun)
        return;
      if (!manual && autoRun) {
        if (refreshDepsAction) {
          refreshDepsAction();
        } else {
          fetchInstance.refresh();
        }
      }
    },
    {
      deep: true,
      immediate: false
    }
  );
  return {
    onBefore: () => {
      if (!vue.unref(ready)) {
        return {
          stopNow: true
        };
      }
    }
  };
};
useAutoRunPlugin.onInit = ({ initialData, ready = true, manual }) => {
  return {
    loading: !manual && vue.unref(ready)
  };
};
module.exports = useAutoRunPlugin;
